#include <string>
#include <iostream>
#include <fstream>
#include <sstream>
#include <vector>

#define STRING	std::string
#define CIN	std::cin
#define COUT	std::cout
#define ENDL	std::endl
#define IVECT	std::vector<int>
#define VVECT	std::vector< std::vector<int> >

STRING inputfilename = "input";

int processes;
int resources;

IVECT maxResources;
IVECT curResources;
VVECT allocated;
VVECT curNeed;
VVECT maxNeed;

std::ofstream logfile;
STRING errorMessage = "Unknown";
STRING safesequence = "No way";

int init()
{
	std::ifstream inputfile;
	inputfile.open(inputfilename.c_str());	
	STRING line;
	IVECT helper;

	errorMessage = "Opening file";
	logfile << "Init: " << errorMessage << ENDL;
	
	if( inputfile == NULL)
		return 0;
	
	errorMessage = "Reading first datas";
	logfile << "Init: " << errorMessage << ENDL;

	inputfile >> processes;
	inputfile >> resources;

	if(processes < 0 || resources < 0)
		return 0;
	
	if( !inputfile.good())
		return 0;
	
	helper.resize(resources);
	maxResources.resize(resources);
	curResources.resize(resources);
	allocated.resize(processes);
	maxNeed.resize(processes);
	curNeed.resize(processes);

	getline(inputfile,line);
	errorMessage = "Reading Max resources";
	logfile << "Init: " << errorMessage << ENDL;
	
	if( !getline(inputfile,line) || line != "Resource:")
		return 0;

	for(int j = 0; j < resources; j++)
	{
		inputfile >> maxResources[j];
		
		if(maxResources[j] < 0)
			return 0;
	}
		
	if( !inputfile.good())
		return 0;

	getline(inputfile,line);
	errorMessage = "Reading Max needs";
	logfile << "Init: " << errorMessage << ENDL;
	
	if( !getline(inputfile,line) || line != "Max:")
		return 0;	

	for(int i = 0; i < processes; i++)
	{
		for(int j = 0; j < resources; j++)
		{
			inputfile >> helper[j];

			if(helper[j] < 0)
				return 0;
		}

		maxNeed[i] = helper;
	}	
	
	if( !inputfile.good())
		return 0;
	
	getline(inputfile,line);
	errorMessage = "Reading Allocated";
	logfile << "Init: " << errorMessage << ENDL;
	
	if( getline(inputfile,line) && line == "Allocated:")
	{
		for(int i = 0; i < processes; i++)
		{
			for(int j = 0; j < resources; j++)
			{
				inputfile >> helper[j];

				if(helper[j] < 0)
					return 0;
			}

			allocated[i] = helper;
		}

		if( !inputfile.good())
		{
			for(int i = 0; i < processes; i++)
				for(int j = 0; j < resources; j++)		
					allocated[i][j] = 0;				
		}
	}
	else
	{
		for(int i = 0; i < processes; i++)
			for(int j = 0; j < resources; j++)		
				allocated[i][j] = 0;		
	}
	
	errorMessage = "Validating input values and computing need";
	logfile << "Init: " << errorMessage << ENDL;

	for(int i = 0; i < processes; i++)
	{
		curNeed[i].resize(resources);
		
		for(int j = 0; j < resources; j++)
		{			
			if( allocated[i][j] > maxNeed[i][j])
			{
				logfile << "Error-> Process: " << i
					<< "Resource: " << j << ENDL;

				return 0;
			}

			curNeed[i][j] = maxNeed[i][j] - allocated[i][j];
		}
	}
	
	errorMessage = "Validating input values and computing remaining resources";
	logfile << "Init: " << errorMessage << ENDL;

	for(int j = 0; j < resources; j++)
	{
		int rescount = 0;
		
		for(int i = 0; i < processes; i++)
			rescount += allocated[i][j];

		if(rescount > maxResources[j])
		{
			logfile << "Error-> Resource: " << j << ENDL;
		
			return 0;
		}

		curResources[j] = maxResources[j] - rescount;
	}

	inputfile.close();
	return 1;
}

void dumpMatrixes()
{
	logfile << processes << "\t" << resources << ENDL;
	logfile << "Resource:" << ENDL;

	for(int j = 0; j < resources; j++)
		logfile << maxResources[j] << "\t";

	logfile << ENDL;
	logfile << "Max:" << ENDL;

	for(int i = 0; i < processes; i++)
	{
		for(int j = 0; j < resources; j++)
			logfile << maxNeed[i][j] << "\t";

		logfile << ENDL;
	}

	logfile << "Allocated:" << ENDL;

	for(int i = 0; i < processes; i++)
	{
		for(int j = 0; j < resources; j++)
			logfile << allocated[i][j] << "\t";

		logfile << ENDL;
	}

	logfile << "Remaining Resource:" << ENDL;

	for(int j = 0; j < resources; j++)
		logfile << curResources[j] << "\t";

	logfile << ENDL;
	logfile << "Current Need:" << ENDL;

	for(int i = 0; i < processes; i++)
	{
		for(int j = 0; j < resources; j++)
			logfile << curNeed[i][j] << "\t";

		logfile << ENDL;
	}
}

int kill(const char * procnum)
{	
	int temp;
	
	if(sscanf(procnum, "%i", &temp) != 1 || temp > processes || temp <= 0)
		return 0;

	temp--;

	if(allocated[temp][0] == -1)
	{
		logfile << "The process#"<< temp + 1 << " has been already killed" << ENDL;
		return 0;
	}
		
	logfile << "Resource Released:" << ENDL;
	COUT << "Resources were releases:" << ENDL;

	for(int i = 0;  i < resources; i++)
		COUT << "R" << i << "\t";

	COUT << ENDL;
		
	for(int i = 0;  i < resources; i++)
	{
		logfile << allocated[temp][i] << "\t";
		COUT << allocated[temp][i] << "\t";
	}

	COUT << ENDL;
	logfile << ENDL;

	for(int i = 0;  i < resources; i++)
	{
		curResources[i] += allocated[temp][i];
		allocated[temp][i] = -1;
		curNeed[temp][i] = -1;
	}

	return 1;
}

STRING int2str(int num)
{
	STRING temp;

	if(num <= 0)
		return "0";

	for(;num != 0; num /= 10)
		temp += '0' + num - ((num / 10) * 10);

	STRING retval;

	for(int i = temp.size() - 1; i >= 0; i--)
		retval += temp[i];

	return retval;
}

int cangrant(IVECT first, IVECT second)
{
	if( first.size() != second.size())
		return 0;

	for(int i = 0; i < first.size(); i++)
		if(first[i] > second[i])
			return 0;

	return 1;
}

void fulfillment( const char * num, const char * request)
{
	int temp;
	int value;
	STRING inputvalues = request;
	
	if(sscanf(num, "%i", &temp) != 1 || temp > processes || temp <= 0)
	{
		COUT << "The process number is not valid" << ENDL;
		logfile << "The process number is not valid" << ENDL;
		return;
	}

	temp--;

	if(allocated[temp][0] == -1)
	{
		COUT << "The process#"<< temp + 1 << " has been killed" << ENDL;	
		logfile << "The process#"<< temp + 1 << " has been killed" << ENDL;
		return;
	}

	IVECT helper;
	helper.resize(resources);

	for(int i = 0; i < helper.size(); i++)
	{
		if(sscanf(inputvalues.c_str(), "%i", &value) != 1)
		{
			COUT << "The number of requests must be equal to resources" << ENDL;
			logfile << "The number of requests must be equal to resources" << ENDL;
			return;
		}

		int j =0;
		
		for(; inputvalues[j] == ' '; j++);

		for(; inputvalues[j] != ' ' && inputvalues[j] != 0; j++)
			inputvalues[j] = ' ';

		helper[i] = value;
	}

	for(int i = 0; i < resources; i++)
	{
		if(allocated[temp][i] < -helper[i])
		{
			COUT << "The process has not enough resources to release" << ENDL;
			logfile << "The process has not enough resources to release" << ENDL;
			return;
		}

		if(helper[i] > curNeed[temp][i])
		{
			COUT << "The process cannot request more than its max need" << ENDL;
			logfile << "The process cannot request more than its max need" << ENDL;
			return;
		}
	}

	for(int i = 0; i < resources; i++)
	{
		if(curResources[i] < helper[i])
		{
			COUT << "System has not enough resources for this request" << ENDL;
			logfile << "System has not enough resources for this request" << ENDL;
			return;
		}
	}

	VVECT newallocated = allocated;
	VVECT newcurNeed = curNeed;
	IVECT newcurResources = curResources;

	for(int i = 0; i < resources; i++)
	{
		newallocated[temp][i] += helper[i];
		newcurNeed[temp][i] -= helper[i];
		newcurResources[i] -= helper[i];
	}
/*

	logfile << processes << "\t" << resources << ENDL;
	logfile << "Resource:" << ENDL;

	for(int j = 0; j < resources; j++)
		logfile << maxResources[j] << "\t";

	logfile << ENDL;
	logfile << "Max:" << ENDL;

	for(int i = 0; i < processes; i++)
	{
		for(int j = 0; j < resources; j++)
			logfile << maxNeed[i][j] << "\t";

		logfile << ENDL;
	}

	logfile << "Allocated:" << ENDL;

	for(int i = 0; i < processes; i++)
	{
		for(int j = 0; j < resources; j++)
			logfile << newallocated[i][j] << "\t";

		logfile << ENDL;
	}

	logfile << "Remaining Resource:" << ENDL;

	for(int j = 0; j < resources; j++)
		logfile << newcurResources[j] << "\t";

	logfile << ENDL;
	logfile << "Current Need:" << ENDL;

	for(int i = 0; i < processes; i++)
	{
		for(int j = 0; j < resources; j++)
			logfile << newcurNeed[i][j] << "\t";

		logfile << ENDL;
	}


*/
	
	STRING scapepath = "<";
	bool haschanged = true;
	
	for(int i = 0; i < processes && haschanged; i++)
	{
		haschanged = false;
		
		for(int j = 0; j < processes; j++)
		{
			if( newallocated[j][0] != -1 && cangrant(newcurNeed[j], newcurResources))
			{
				haschanged = true;

				for( int k = 0; k < resources; k++)
				{
					newcurResources[k] += newallocated[j][k];
					newallocated[j][k] = -1;
					newcurNeed[j][k] = -1;
				}
				
				scapepath += " P";
				scapepath += int2str(j + 1);

				break;
			}
		}
	}

	for(int i = 0; i < processes; i++)
	{
		if(newallocated[i][0] != -1)
		{
			COUT << "This request could cause a deadlock" << ENDL;
			logfile << "This request could cause a deadlock" << ENDL;
			return;
		}
	}

	for(int i = 0; i < resources; i++)
	{
		allocated[temp][i] += helper[i];
		curNeed[temp][i] -= helper[i];
		curResources[i] -= helper[i];		
	}

	COUT << "The request was accepted" << ENDL;
	logfile << "The request was accepted" << ENDL;
	safesequence = scapepath + " >";

	for(int i = 0; i < resources; i++)
	{
		if(curNeed[temp][i] != 0)
			return;
	}

	for(int i = 0;  i < resources; i++)
	{
		curResources[i] += allocated[temp][i];
		allocated[temp][i] = -1;
		curNeed[temp][i] = -1;
	}

	logfile << "Process " << temp + 1 << " has ended" << ENDL;
}

int main()
{
	logfile.open("log");

	if(!init())
	{
		COUT << "Error: " << errorMessage << ENDL;
		logfile.close();

		return 0;
	}

	int args;
	char command[256];
	STRING allcommands[] = { "kill", "req", "safeseq", "showmaxneed", "showallocation", "quit", "dump"};
	char * argv[256];
	command[0] = 0;
	char requests[256];
	requests[0] = 0;
	
	for(;;)
	{
		COUT << "/> ";
		CIN.getline( command, 255);
		
		while(command[0] == 0)
			CIN.getline( command, 255);
		
		args = 0;

		for( int ind = 0; command[ind] != 0;)
		{
			argv[args] = command + ind;			
				
			while( command[ind] != ' ' && command[ind] != 0)
				ind++;

			if( command[ind] != 0)
			{
				command[ind] = 0;
				ind++;
			}

			args++;	
			argv[args] = NULL;
		}
	
		if( argv[0] == NULL)
			continue;

		if( allcommands[0] == argv[0])
		{
			logfile << argv[0] << " " << argv[1] << ENDL;
		
			if( args == 2)
			{
				if(!kill(argv[1]))
					COUT << "The kill instruction gets a valid process number"
					     << " for an active process" << ENDL;
			}
			else
				COUT << "The kill instruction gets 1 parameter !!" << ENDL;
		}
		else if( allcommands[1] == argv[0])
		{
			logfile << argv[0] << " " << argv[1] << ENDL;

			if( args == 2)
			{
				COUT << "request: ";
				CIN.getline( requests, 255);
		
				while(command[0] == 0)
					CIN.getline( requests, 255);

				logfile << "request: " << requests << ENDL;

				fulfillment(argv[1], requests);
			}
			else
				COUT << "The req instruction gets 1 parameter !!" << ENDL;
		}
		else if( allcommands[2] == argv[0])
		{
			logfile << argv[0] << ENDL;

			if( args == 1)
			{
				COUT << safesequence << ENDL;
			}
			else				
				COUT << "The safeseq instruction gets 0 parameter !!" << ENDL;		
		}
		else if( allcommands[3] == argv[0])
		{
			logfile << argv[0] << ENDL;

			if( args == 1)
			{
				COUT << "Max Need:" << ENDL;

				for(int i = 0; i < processes; i++)
				{
					for(int j = 0; j < resources; j++)
						COUT << maxNeed[i][j] << "\t";
					
					COUT << ENDL;
				}			
			}
			else				
				COUT << "The showmaxneed instruction gets 0 parameter !!" << ENDL;
		}
		else if( allcommands[4] == argv[0])
		{
			logfile << argv[0] << ENDL;

			if( args == 1)
			{
				COUT << "Allocated:" << ENDL;

				for(int i = 0; i < processes; i++)
				{
					for(int j = 0; j < resources; j++)
						COUT << allocated[i][j] << "\t";

					COUT << ENDL;
				}
			}
			else				
				COUT << "The showallocation instruction gets 0 parameter !!" << ENDL;
		}
		else if( allcommands[5] == argv[0])
		{
			logfile << argv[0] << ENDL;

			if( args == 1)
			{
				break;
			}
			else				
				COUT << "The quit instruction gets 0 parameter !!" << ENDL;
		}
		else if( allcommands[6] == argv[0])
		{
			logfile << argv[0] << ENDL;

			if( args == 1)
			{
				dumpMatrixes();
			}
			else				
				COUT << "The dump instruction gets 0 parameter !!" << ENDL;
		}	
		else
		{
			COUT << "Unknown command !!" << ENDL;
			continue;
		}
	}

	logfile.close();
	return 0;
}

